diff --git a/Makefile-test.am b/Makefile-test.am
index a18df221d..377b14ea5 100644
--- a/Makefile-test.am
+++ b/Makefile-test.am
@@ -88,6 +88,7 @@ TESTS_UNIT  = \
     test/unit/tctildr-nodl \
     test/unit/tctildr-tcti \
     test/unit/tctildr-getinfo \
+    test/unit/tcti-spi-helper \
     test/unit/dlopen-fail \
     test/unit/dlopen-UINT8-marshal \
     test/unit/dlopen-TPM2B-marshal \
@@ -471,6 +472,10 @@ test_unit_tcti_cmd_SOURCES = test/unit/tcti-cmd.c \
     src/tss2-tcti/tcti-cmd.c src/tss2-tcti/tcti-cmd.h test/unit/tcti-cmd-test.h
 endif
 
+test_unit_tcti_spi_helper_CFLAGS  = $(CMOCKA_CFLAGS) $(TESTS_CFLAGS)
+test_unit_tcti_spi_helper_LDADD   = $(CMOCKA_LIBS) $(libtss2_tcti_spi_helper)
+test_unit_tcti_spi_helper_SOURCES = test/unit/tcti-spi-helper.c
+
 test_unit_tctildr_CFLAGS = $(CMOCKA_CFLAGS) $(TESTS_CFLAGS)
 test_unit_tctildr_LDADD = $(CMOCKA_LIBS) $(libutil)
 test_unit_tctildr_LDFLAGS = -Wl,--wrap=calloc,--wrap=free \
diff --git a/Makefile.am b/Makefile.am
index 02eb162d9..fee8147a6 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -398,6 +398,27 @@ endif # ENABLE_TCTI_CMD
 EXTRA_DIST += lib/tss2-tcti-cmd.map \
               lib/tss2-tcti-cmd.def
 
+# tcti library for spi connected tpms
+if ENABLE_TCTI_SPI_HELPER
+libtss2_tcti_spi_helper = src/tss2-tcti/libtss2-tcti-spi-helper.la
+tss2_HEADERS += $(srcdir)/include/tss2/tss2_tcti_spi_helper.h
+lib_LTLIBRARIES += $(libtss2_tcti_spi_helper)
+pkgconfig_DATA += lib/tss2-tcti-spi-helper.pc
+EXTRA_DIST += lib/tss2-tcti-spi-helper.map \
+              lib/tss2-tcti-spi-helper.def
+
+if HAVE_LD_VERSION_SCRIPT
+if !UNIT
+src_tss2_tcti_libtss2_tcti_spi_helper_la_LDFLAGS  = -Wl,--version-script=$(srcdir)/lib/tss2-tcti-spi-helper.map
+endif # UNIT
+endif # HAVE_LD_VERSION_SCRIPT
+src_tss2_tcti_libtss2_tcti_spi_helper_la_LIBADD   = $(libutil) $(libtss2_mu)
+src_tss2_tcti_libtss2_tcti_spi_helper_la_SOURCES  = \
+    src/tss2-tcti/tcti-common.c \
+    src/tss2-tcti/tcti-spi-helper.c \
+    src/tss2-tcti/tcti-spi-helper.h
+endif # ENABLE_TCTI_SPI_HELPER
+
 ### TCG TSS SYS spec library ###
 libtss2_sys = src/tss2-sys/libtss2-sys.la
 tss2_HEADERS += $(srcdir)/include/tss2/tss2_sys.h
diff --git a/configure.ac b/configure.ac
index c873b7691..3593b8d2e 100644
--- a/configure.ac
+++ b/configure.ac
@@ -15,7 +15,7 @@ m4_ifdef([AM_SILENT_RULES], [AM_SILENT_RULES([yes])]) #Backward compatible setti
 
 AC_CONFIG_HEADERS([config.h])
 
-AC_CONFIG_FILES([Makefile Doxyfile lib/tss2-sys.pc lib/tss2-esys.pc lib/tss2-mu.pc lib/tss2-tcti-device.pc lib/tss2-tcti-mssim.pc lib/tss2-tcti-swtpm.pc lib/tss2-tcti-pcap.pc lib/tss2-tcti-libtpms.pc lib/tss2-rc.pc lib/tss2-tctildr.pc lib/tss2-fapi.pc lib/tss2-tcti-cmd.pc lib/tss2-policy.pc])
+AC_CONFIG_FILES([Makefile Doxyfile lib/tss2-sys.pc lib/tss2-esys.pc lib/tss2-mu.pc lib/tss2-tcti-device.pc lib/tss2-tcti-mssim.pc lib/tss2-tcti-swtpm.pc lib/tss2-tcti-pcap.pc lib/tss2-tcti-libtpms.pc lib/tss2-rc.pc lib/tss2-tctildr.pc lib/tss2-fapi.pc lib/tss2-tcti-cmd.pc lib/tss2-policy.pc lib/tss2-tcti-spi-helper.pc])
 
 # propagate configure arguments to distcheck
 AC_SUBST([DISTCHECK_CONFIGURE_FLAGS],[$ac_configure_args])
@@ -242,6 +242,15 @@ AM_CONDITIONAL([ENABLE_TCTI_CMD], [test "x$enable_tcti_cmd" != xno])
 AS_IF([test "x$enable_tcti_cmd" = "xyes"],
 	[AC_DEFINE([TCTI_CMD],[1], [TCTI FOR COMMAND BASED ACCESS TO TPM2 DEVICE])])
 
+AC_ARG_ENABLE([tcti-spi-helper],
+            [AS_HELP_STRING([--disable-tcti-spi-helper],
+                            [don't build the tcti-spi-helper module])],,
+            [enable_tcti_spi_helper=yes])
+
+AM_CONDITIONAL([ENABLE_TCTI_SPI_HELPER], [test "x$enable_tcti_spi_helper" != xno])
+AS_IF([test "x$enable_tcti_spi_helper" = "xyes"],
+	[AC_DEFINE([TCTI_SPI_HELPER],[1], [TCTI HELPER FOR SPI BASED ACCESS TO TPM2 DEVICE])])
+
 AC_ARG_ENABLE([tcti-fuzzing],
             [AS_HELP_STRING([--enable-tcti-fuzzing],
                             [build the tcti-fuzzing module])],,
diff --git a/doc/tcti-spi-helper.md b/doc/tcti-spi-helper.md
new file mode 100644
index 000000000..ca6a4c627
--- /dev/null
+++ b/doc/tcti-spi-helper.md
@@ -0,0 +1,246 @@
+# SPI TCTI Helper
+
+The SPI TCTI helper can be used for TPM communication over SPI e.g. in embedded systems like the ESP32.
+It uses user supplied methods for SPI and timing operations in order to be platform independent.
+These methods are supplied to `Tss2_Tcti_Spi_Helper_Init` via the `TSS2_TCTI_SPI_HELPER_PLATFORM` struct.
+
+## Platform methods
+
+Documentation on what the implementation for the platform methods should do can be found in `tss2_tcti_spi_helper.h`.
+See also the example implementation for an ESP32 using the ESP-IDF below.
+
+## Example platform methods and TCTI creation for the ESP32 using ESP-IDF
+
+```C
+/* SPDX-License-Identifier: BSD-2-Clause */
+/*
+ * Copyright 2020 Fraunhofer SIT. All rights reserved.
+ */
+#include <stdio.h>
+#include <string.h>
+#include <stdlib.h>
+#include <stdbool.h>
+#include <freertos/FreeRTOS.h>
+#include <freertos/task.h>
+#include <driver/gpio.h>
+#include <driver/spi_master.h>
+#include <tss2/tss2_tcti_spi_helper.h>
+
+// Example pin defines
+#define PIN_NUM_MISO 19
+#define PIN_NUM_MOSI 27
+#define PIN_NUM_CLK  5
+#define PIN_NUM_CS   18
+#define PIN_NUM_RST  14
+
+// Custom SPI TCTI user data storing SPI handles & timeouts
+typedef struct {
+    spi_device_handle_t spi;
+    gpio_num_t cs_pin;
+    int64_t timeout_expiry;
+} PLATFORM_USERDATA;
+
+// Aquire SPI bus and keep pulling CS
+TSS2_RC platform_spi_acquire (void* user_data)
+{
+    // Cast our user data
+    PLATFORM_USERDATA* platform_data = (PLATFORM_USERDATA*) user_data;
+
+    // Reserve SPI bus until transaction is over and keep pulling CS
+    gpio_set_level(platform_data->cs_pin, 0);
+    spi_device_acquire_bus(platform_data->spi, portMAX_DELAY);
+
+    return TSS2_RC_SUCCESS;
+}
+
+// Release SPI bus and CS
+TSS2_RC platform_spi_release (void* user_data)
+{
+    // Cast our user data
+    PLATFORM_USERDATA* platform_data = (PLATFORM_USERDATA*) user_data;
+
+    // Release CS and release the bus for other devices
+    gpio_set_level(platform_data->cs_pin, 1);
+    spi_device_release_bus(platform_data->spi);
+
+    return TSS2_RC_SUCCESS;
+}
+
+// Transfer cnt bytes from data_out to device and read response into data_in
+TSS2_RC platform_spi_transfer (void* user_data, const void *data_out, void *data_in, size_t cnt)
+{
+    // Cast our user data
+    PLATFORM_USERDATA* platform_data = (PLATFORM_USERDATA*) user_data;
+
+    // Maximum transfer size is 64 byte because we don't use DMA (and the TPM doesn't support more anyway)
+    if (cnt > 64) {
+        return TSS2_TCTI_RC_BAD_VALUE;
+    }
+
+    // At least one of the buffers has to be set
+    if (data_out == NULL && data_in == NULL) {
+        return TSS2_TCTI_RC_BAD_VALUE;
+    }
+
+    // Clear receive buffer
+    if (data_in != NULL) {
+        memset(data_in, 0, cnt);
+    }
+
+    // Setup transaction
+    spi_transaction_t t;
+    memset(&t, 0, sizeof(t));
+    t.length = cnt*8;
+    t.tx_buffer = data_out;
+    t.rx_buffer = data_in;
+
+    // Transmit
+    esp_err_t ret = spi_device_polling_transmit(platform_data->spi, &t);
+    if (ret != ESP_OK) {
+        return TSS2_TCTI_RC_IO_ERROR;
+    }
+
+    return TSS2_RC_SUCCESS;
+}
+
+// Sleeps for the specified amount of milliseconds
+void platform_sleep_ms (void* user_data, int32_t milliseconds)
+{
+    // Sleep the specified amount of milliseconds
+    vTaskDelay(milliseconds / portTICK_PERIOD_MS);
+}
+
+// Start a timeout timer with specified expiry in milliseconds
+void platform_start_timeout (void* user_data, int32_t milliseconds)
+{
+    // Cast our user data
+    PLATFORM_USERDATA* platform_data = (PLATFORM_USERDATA*) user_data;
+
+    // Store timeout expiry time
+    platform_data->timeout_expiry = esp_timer_get_time() + (milliseconds*1000);
+}
+
+// Check if the timeout timer started by platform_start_timeout has already expired
+bool platform_timeout_expired (void* user_data)
+{
+    // Cast our user data
+    PLATFORM_USERDATA* platform_data = (PLATFORM_USERDATA*) user_data;
+
+    // Check if timeout already expired
+    return esp_timer_get_time() < platform_data->timeout_expiry;
+}
+
+// Frees the platform user_data struct and everything inside
+void platform_finalize(void* user_data)
+{
+    // Cast our user data
+    PLATFORM_USERDATA* platform_data = (PLATFORM_USERDATA*) user_data;
+
+    // Free resources inside user_data like SPI device handles here
+    // ...
+
+    // Free user_data
+    free(platform_data);
+}
+
+// Creates a new platform struct with the given SPI device handle and chip select
+TSS2_TCTI_SPI_HELPER_PLATFORM create_tcti_spi_helper_platform(spi_device_handle_t spi, gpio_num_t cs_pin)
+{
+    // Create required platform user data
+    PLATFORM_USERDATA* platform_data = malloc(sizeof(PLATFORM_USERDATA));
+    platform_data->spi = spi;
+    platform_data->cs_pin = cs_pin;
+    platform_data->timeout_expiry = 0;
+
+    // Create TCTI SPI platform struct with custom platform methods
+    TSS2_TCTI_SPI_HELPER_PLATFORM platform;
+    platform.user_data = platform_data;
+    platform.sleep_ms = platform_sleep_ms;
+    platform.start_timeout = platform_start_timeout;
+    platform.timeout_expired = platform_timeout_expired;
+    platform.spi_acquire = platform_spi_acquire;
+    platform.spi_release = platform_spi_release;
+    platform.spi_transfer = platform_spi_transfer;
+    platform.finalize = platform_finalize;
+
+    return platform;
+}
+
+// Creates a SPI TCTI using the example pin defines
+TSS2_TCTI_CONTEXT* create_tcti_ctx()
+{
+    // SPI bus & devive configuration
+    spi_bus_config_t bus_cfg = {
+        .miso_io_num = PIN_NUM_MISO,
+        .mosi_io_num = PIN_NUM_MOSI,
+        .sclk_io_num = PIN_NUM_CLK,
+        .quadwp_io_num = -1,
+        .quadhd_io_num = -1,
+        .max_transfer_sz = 64
+    };
+    spi_device_interface_config_t dev_cfg = {
+        .clock_speed_hz = 10*1000*1000, // 10MHz, but tested up to 22MHz
+        .mode = 0,
+        .spics_io_num = -1,
+        .queue_size = 1,
+        .pre_cb = NULL,
+        .post_cb = NULL,
+    };
+
+    // Initializing CS pin
+    gpio_pad_select_gpio(PIN_NUM_CS);
+    gpio_set_direction(PIN_NUM_CS, GPIO_MODE_OUTPUT);
+    gpio_set_level(PIN_NUM_CS, 1);
+
+    // Initialize the SPI bus and device
+    esp_err_t ret;
+    ret = spi_bus_initialize(HSPI_HOST, &bus_cfg, 0);
+    ESP_ERROR_CHECK(ret);
+
+    // Attach the device to the SPI bus
+    spi_device_handle_t spi;
+    ret = spi_bus_add_device(HSPI_HOST, &dev_cfg, &spi);
+    ESP_ERROR_CHECK(ret);
+
+    // Reset TPM device (and wait a bit in between)
+    gpio_pad_select_gpio(PIN_NUM_RST);
+    gpio_set_direction(PIN_NUM_RST, GPIO_MODE_OUTPUT);
+    gpio_set_level(PIN_NUM_RST, 0);
+    vTaskDelay(10 / portTICK_PERIOD_MS);
+    gpio_set_level(PIN_NUM_RST, 1);
+    vTaskDelay(10 / portTICK_PERIOD_MS);
+
+    // Create TCTI config with our custom platform methods
+    TSS2_TCTI_SPI_HELPER_PLATFORM tcti_platform;
+    tcti_platform = create_tcti_spi_helper_platform(spi, PIN_NUM_CS);
+
+    // Create TCTI
+    size_t size;
+    TSS2_RC rc;
+    TSS2_TCTI_CONTEXT* tcti_ctx;
+
+    // Get requested TCTI context size
+    rc = Tss2_Tcti_Spi_Helper_Init(NULL, &size, tcti_platform);
+    if (rc != TSS2_RC_SUCCESS) {
+        printf("Failed to get allocation size for device tcti context: 0x%x\n", rc);
+        return NULL;
+    }
+
+    // Allocate TCTI context size
+    tcti_ctx = (TSS2_TCTI_CONTEXT*) calloc(1, size);
+    if (tcti_ctx == NULL) {
+        printf("Allocation for device TCTI context failed\n");
+        return NULL;
+    }
+
+    // Initialize TCTI context
+    rc = Tss2_Tcti_Spi_Helper_Init(tcti_ctx, &size, tcti_platform);
+    if (rc != TSS2_RC_SUCCESS) {
+        printf("Failed to initialize device TCTI context: 0x%x\n", rc);
+        free(tcti_ctx);
+        return NULL;
+    }
+
+    return tcti_ctx;
+}
+```
\ No newline at end of file
diff --git a/include/tss2/tss2_tcti_spi_helper.h b/include/tss2/tss2_tcti_spi_helper.h
new file mode 100644
index 000000000..1b94a425f
--- /dev/null
+++ b/include/tss2/tss2_tcti_spi_helper.h
@@ -0,0 +1,96 @@
+/* SPDX-License-Identifier: BSD-2-Clause */
+/*
+ * Copyright 2020 Fraunhofer SIT. All rights reserved.
+ */
+#ifndef TSS2_TCTI_SPI_HELPER_HELPER_H
+#define TSS2_TCTI_SPI_HELPER_HELPER_H
+
+#include <stdbool.h>
+#include "tss2_tcti.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/*
+ * Forward declaration
+ *
+ * See doc/tcti-spi-helper.md for example platform method implementations.
+ */
+typedef struct TSS2_TCTI_SPI_HELPER_PLATFORM TSS2_TCTI_SPI_HELPER_PLATFORM;
+
+/*
+ * Sleeps for the specified amount of milliseconds
+ */
+typedef void (*TSS2_TCTI_SPI_HELPER_PLATFORM_SLEEP_MS_FUNC) (void* user_data, int milliseconds);
+
+/*
+ * Starts a timeout timer which expires in the specified amount of milliseconds.
+ * This can be done by storing the expire time (now + milliseconds) in the userdata.
+ */
+typedef void (*TSS2_TCTI_SPI_HELPER_PLATFORM_START_TIMEOUT_FUNC) (void* user_data, int milliseconds);
+
+/*
+ * Returns true if the timeout started previously by START_TIMEOUT_FUNC already has expired, false otherwise.
+ * This can be done e.g. by comparing the current time and the stored timer expire time.
+ * This method will be called often when waiting for timeouts and should be fast.
+ */
+typedef bool (*TSS2_TCTI_SPI_HELPER_PLATFORM_TIMEOUT_EXPIRED_FUNC) (void* user_data);
+
+/*
+ * Reserves the SPI bus until the transaction is over and SPI_RELEASE_FUNC is called.
+ * Make sure the chip select stays pulled the entire time over multiple calls to SPI_TRANSFER_FUNC
+ * until SPI_RELEASE_FUNC is called in the end!!!
+ */
+typedef TSS2_RC (*TSS2_TCTI_SPI_HELPER_PLATFORM_SPI_ACQUIRE_FUNC) (void* user_data);
+
+/*
+ * Stops pulling chip select and releases the SPI bus again.
+ */
+typedef TSS2_RC (*TSS2_TCTI_SPI_HELPER_PLATFORM_SPI_RELEASE_FUNC) (void* user_data);
+
+/*
+ * Transfers cnt bytes from data_out to the SPI slave. Reads the response into data_in.
+ */
+typedef TSS2_RC (*TSS2_TCTI_SPI_HELPER_PLATFORM_SPI_TRANSFER_FUNC) (void* user_data, const void *data_out, void *data_in, size_t cnt);
+
+/*
+ * Is called by Tss2_Tcti_Finalize right before the TCTI context is destroyed and
+ * should free user_data and all resources inside like e.g. SPI device handles.
+ */
+typedef void (*TSS2_TCTI_SPI_HELPER_PLATFORM_FINALIZE) (void* user_data);
+
+/*
+ * Contains user implemented platform methods for the SPI TCTI.
+ *
+ * See doc/tcti-spi-helper.md for example implementations.
+ */
+struct TSS2_TCTI_SPI_HELPER_PLATFORM {
+    void* user_data;
+    TSS2_TCTI_SPI_HELPER_PLATFORM_SLEEP_MS_FUNC sleep_ms;
+    TSS2_TCTI_SPI_HELPER_PLATFORM_START_TIMEOUT_FUNC start_timeout;
+    TSS2_TCTI_SPI_HELPER_PLATFORM_TIMEOUT_EXPIRED_FUNC timeout_expired;
+    TSS2_TCTI_SPI_HELPER_PLATFORM_SPI_ACQUIRE_FUNC spi_acquire;
+    TSS2_TCTI_SPI_HELPER_PLATFORM_SPI_RELEASE_FUNC spi_release;
+    TSS2_TCTI_SPI_HELPER_PLATFORM_SPI_TRANSFER_FUNC spi_transfer;
+    TSS2_TCTI_SPI_HELPER_PLATFORM_FINALIZE finalize;
+};
+
+/*
+ * Initializes the SPI TCTI with a context pointer and platform methods.
+ * When the tctiContext pointer is NULL, the needed buffer size is written to *size.
+ * platform_conf contains platform methods implemented by the user for SPI
+ * communication and timeout handling.
+ *
+ * See doc/tcti-spi-helper.md for example implementations.
+ */
+TSS2_RC Tss2_Tcti_Spi_Helper_Init (
+    TSS2_TCTI_CONTEXT *tctiContext,
+    size_t *size,
+    TSS2_TCTI_SPI_HELPER_PLATFORM platform_conf);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* TSS2_TCTI_SPI_HELPER_HELPER_H */
diff --git a/lib/tss2-tcti-spi-helper.def b/lib/tss2-tcti-spi-helper.def
new file mode 100644
index 000000000..247c3d962
--- /dev/null
+++ b/lib/tss2-tcti-spi-helper.def
@@ -0,0 +1,4 @@
+LIBRARY tss2-tcti-spi-helper
+EXPORTS
+    Tss2_Tcti_Info
+    Tss2_Tcti_Spi_Helper_Init
diff --git a/lib/tss2-tcti-spi-helper.map b/lib/tss2-tcti-spi-helper.map
new file mode 100644
index 000000000..2f7488cd2
--- /dev/null
+++ b/lib/tss2-tcti-spi-helper.map
@@ -0,0 +1,7 @@
+{
+    global:
+        Tss2_Tcti_Info;
+        Tss2_Tcti_Spi_Helper_Init;
+    local:
+        *;
+};
diff --git a/lib/tss2-tcti-spi-helper.pc.in b/lib/tss2-tcti-spi-helper.pc.in
new file mode 100644
index 000000000..5667a1f6e
--- /dev/null
+++ b/lib/tss2-tcti-spi-helper.pc.in
@@ -0,0 +1,11 @@
+prefix=@prefix@
+exec_prefix=@exec_prefix@
+libdir=@libdir@
+includedir=@includedir@
+
+Name: tss2-tcti-spi-helper
+Description: TCTI library for communicating with the TPM over SPI.
+URL: https://github.com/tpm2-software/tpm2-tss
+Version: @VERSION@
+Cflags: -I${includedir} -I${includedir}/tss
+Libs: -ltss2-tcti-spi-helper -L${libdir}
diff --git a/man/tss2-tcti-spi-helper.7.in b/man/tss2-tcti-spi-helper.7.in
new file mode 100644
index 000000000..3bc3caa06
--- /dev/null
+++ b/man/tss2-tcti-spi-helper.7.in
@@ -0,0 +1,14 @@
+.\" Process this file with
+.\" groff -man -Tascii foo.1
+.\"
+.TH TCTI-SPI 7 "OCTOBER 2020" "TPM2 Software Stack"
+.SH NAME
+tcti-spi-helper \- device driver TCTI library
+.SH SYNOPSIS
+A TPM Command Transmission Interface (TCTI) module for communication via SPI.
+TPM device driver.
+.SH DESCRIPTION
+tcti-spi-helper is a library that abstracts the details of communication with a TPM
+via SPI protocol. It uses user supplied methods for SPI and timing operations
+in order to be platform independent. These methods are supplied to `Tss2_Tcti_Spi_Init`
+via the `TSS2_TCTI_SPI_PLATFORM` struct.
diff --git a/src/tss2-tcti/tcti-spi-helper.c b/src/tss2-tcti/tcti-spi-helper.c
new file mode 100644
index 000000000..6ba174d46
--- /dev/null
+++ b/src/tss2-tcti/tcti-spi-helper.c
@@ -0,0 +1,725 @@
+/* SPDX-License-Identifier: BSD-2-Clause */
+/*
+ * Copyright 2020 Fraunhofer SIT. All rights reserved.
+ */
+#include <errno.h>
+#include <fcntl.h>
+#include <inttypes.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <stdbool.h>
+#include <string.h>
+#include <sys/stat.h>
+#include <sys/types.h>
+#include <unistd.h>
+
+#include "tss2_tcti.h"
+#include "tss2_tcti_spi_helper.h"
+#include "tss2_mu.h"
+#include "tcti-common.h"
+#include "tcti-spi-helper.h"
+#include "util/io.h"
+#define LOGMODULE tcti
+#include "util/log.h"
+
+static inline void spi_tpm_helper_delay_ms(TSS2_TCTI_SPI_HELPER_CONTEXT* ctx, int milliseconds)
+{
+    // Sleep a specified amount of milliseconds
+    ctx->platform.sleep_ms(ctx->platform.user_data, milliseconds);
+}
+
+static inline void spi_tpm_helper_start_timeout(TSS2_TCTI_SPI_HELPER_CONTEXT* ctx, int milliseconds)
+{
+    // Start a timeout timer with the specified amount of milliseconds
+    ctx->platform.start_timeout(ctx->platform.user_data, milliseconds);
+}
+
+static inline bool spi_tpm_helper_timeout_expired(TSS2_TCTI_SPI_HELPER_CONTEXT* ctx)
+{
+    // Check if the last started tiemout expired
+    return ctx->platform.timeout_expired(ctx->platform.user_data);
+}
+
+static inline TSS2_RC spi_tpm_helper_spi_acquire(TSS2_TCTI_SPI_HELPER_CONTEXT* ctx)
+{
+    if (ctx->platform.spi_acquire == NULL) {
+        return TSS2_RC_SUCCESS;
+    }
+
+    // Reserve SPI bus until transaction is over and keep pulling CS
+    return ctx->platform.spi_acquire(ctx->platform.user_data);
+}
+
+static inline TSS2_RC spi_tpm_helper_spi_release(TSS2_TCTI_SPI_HELPER_CONTEXT* ctx)
+{
+    if (ctx->platform.spi_release == NULL) {
+        return TSS2_RC_SUCCESS;
+    }
+
+    // Release SPI bus and release CS
+    return ctx->platform.spi_release(ctx->platform.user_data);
+}
+
+static inline TSS2_RC spi_tpm_helper_spi_transfer(TSS2_TCTI_SPI_HELPER_CONTEXT* ctx, const void *data_out, void *data_in, size_t cnt)
+{
+    // Perform SPI transaction with cnt bytes
+    return ctx->platform.spi_transfer(ctx->platform.user_data, data_out, data_in, cnt);
+}
+
+static inline void spi_tpm_helper_platform_finalize(TSS2_TCTI_SPI_HELPER_CONTEXT* ctx)
+{
+    // Free user_data and resources inside
+    ctx->platform.finalize(ctx->platform.user_data);
+}
+
+static inline uint32_t spi_tpm_helper_read_be32(const void *src)
+{
+    const uint8_t *s = src;
+    return (((uint32_t)s[0]) << 24) | (((uint32_t)s[1]) << 16) | (((uint32_t)s[2]) << 8) | (((uint32_t)s[3]) << 0);
+}
+
+static TSS2_RC spi_tpm_helper_start_transaction(TSS2_TCTI_SPI_HELPER_CONTEXT* ctx, enum TCTI_SPI_HELPER_REGISTER_ACCESS_TYPE access, size_t bytes, uint32_t addr)
+{
+    TSS2_RC rc;
+
+    // Build spi header
+    uint8_t header[4];
+
+    // Transaction type and transfer size
+    header[0] = ((access == TCTI_SPI_HELPER_REGISTER_READ) ? 0x80 : 0x00) | (bytes - 1);
+
+    // TPM register address
+    header[1] = addr >> 16 & 0xff;
+    header[2] = addr >> 8  & 0xff;
+    header[3] = addr >> 0  & 0xff;
+
+    // Reserve SPI bus until transaction is over and keep pulling CS
+    rc = spi_tpm_helper_spi_acquire(ctx);
+    if (rc != TSS2_RC_SUCCESS) {
+        return TSS2_TCTI_RC_IO_ERROR;
+    }
+
+    // Send header
+    uint8_t header_response[4];
+    rc = spi_tpm_helper_spi_transfer(ctx, header, header_response, 4);
+    if (rc != TSS2_RC_SUCCESS) {
+        return TSS2_TCTI_RC_IO_ERROR;
+    }
+
+    // Wait until the TPM exits the wait state and sends a 1 bit
+    uint8_t byte;
+
+    // The 1 bit is often already set in the last byte of the transaction header
+    byte = header_response[3];
+    if (byte & 1) {
+        return TSS2_RC_SUCCESS;
+    }
+
+    // With most current TPMs there shouldn't be any more waitstate at all, but according to
+    // the spec, we have to retry until there is no more waitstate inserted. So we try again
+    // a few times by reading only one byte at a time and waiting in between.
+    uint8_t zero = 0;
+    for (int retries = 256; retries > 0; retries--) {
+        rc = spi_tpm_helper_spi_transfer(ctx, &zero, &byte, 1);
+        if (rc != TSS2_RC_SUCCESS) {
+            return TSS2_TCTI_RC_IO_ERROR;
+        }
+        if (byte & 1) {
+            return TSS2_RC_SUCCESS;
+        }
+        spi_tpm_helper_delay_ms(ctx, 1);
+    }
+
+    // The TPM did not exit the wait state in time
+    return TSS2_TCTI_RC_IO_ERROR;
+}
+
+static TSS2_RC spi_tpm_helper_end_transaction(TSS2_TCTI_SPI_HELPER_CONTEXT* ctx)
+{
+    // Release CS (ends the transaction) and release the bus for other devices
+    return spi_tpm_helper_spi_release(ctx);
+}
+
+static void spi_tpm_helper_log_register_access(enum TCTI_SPI_HELPER_REGISTER_ACCESS_TYPE access, uint32_t reg_number, const void *buffer, size_t cnt, char* err) {
+
+#if MAXLOGLEVEL == LOGL_NONE
+    (void) access;
+    (void) reg_number;
+    (void) buffer;
+    (void) cnt;
+    (void) err;
+#else
+    // Print register access debug information
+    char* access_str = (access == TCTI_SPI_HELPER_REGISTER_READ) ? "READ" : "WRITE";
+
+    if (err != NULL) {
+        LOG_ERROR("%s register %#02x (%zu bytes) %s", access_str, reg_number, cnt, err);
+    } else {
+#if MAXLOGLEVEL < LOGL_TRACE
+        (void) buffer;
+#else
+        LOGBLOB_TRACE(buffer, cnt, "%s register %#02x (%zu bytes)", access_str, reg_number, cnt);
+#endif
+    }
+#endif
+}
+
+static size_t spi_tpm_helper_no_waitstate_preprocess(enum TCTI_SPI_HELPER_REGISTER_ACCESS_TYPE access, uint32_t addr, uint8_t *buffer1, uint8_t *buffer2, size_t cnt)
+{
+    // Transaction type and transfer size
+    buffer2[0] = ((access == TCTI_SPI_HELPER_REGISTER_READ) ? 0x80 : 0x00) | (cnt - 1);
+
+    // TPM register address
+    buffer2[1] = addr >> 16 & 0xff;
+    buffer2[2] = addr >> 8  & 0xff;
+    buffer2[3] = addr >> 0  & 0xff;
+
+    if (access == TCTI_SPI_HELPER_REGISTER_WRITE) {
+        memcpy(&buffer2[4], buffer1, cnt);
+    } else {
+        memset(&buffer2[4], 0, cnt);
+    }
+
+    return cnt + 4;
+}
+
+static void spi_tpm_helper_no_waitstate_postprocess(enum TCTI_SPI_HELPER_REGISTER_ACCESS_TYPE access, uint8_t *buffer1, uint8_t *buffer2, size_t cnt)
+{
+    if (access == TCTI_SPI_HELPER_REGISTER_WRITE) {
+        return;
+    }
+
+    memcpy(buffer1, &buffer2[4], cnt - 4);
+}
+
+static TSS2_RC spi_tpm_helper_read_reg(TSS2_TCTI_SPI_HELPER_CONTEXT* ctx, uint32_t reg_number, void *buffer, size_t cnt)
+{
+    TSS2_RC rc;
+    enum TCTI_SPI_HELPER_REGISTER_ACCESS_TYPE access = TCTI_SPI_HELPER_REGISTER_READ;
+    bool has_waitstate = true;
+    uint8_t buffer2[68];
+    size_t cnt2 = 0;
+
+    // Check maximum register transfer size is 64 byte
+    if (cnt > 64) {
+        return TSS2_TCTI_RC_BAD_VALUE;
+    }
+
+    // Detect wait state configuration
+    if (ctx->platform.spi_acquire == NULL || ctx->platform.spi_release == NULL) {
+        has_waitstate = false;
+    }
+
+    if (has_waitstate) {
+        // Start read transaction
+        rc = spi_tpm_helper_start_transaction(ctx, access, cnt, reg_number);
+        if (rc != TSS2_RC_SUCCESS) {
+            spi_tpm_helper_log_register_access(access, reg_number, NULL, cnt, "failed in transaction start");
+            spi_tpm_helper_end_transaction(ctx);
+            return TSS2_TCTI_RC_IO_ERROR;
+        }
+        // Read register
+        rc = spi_tpm_helper_spi_transfer(ctx, NULL, buffer, cnt);
+        if (rc != TSS2_RC_SUCCESS) {
+            spi_tpm_helper_log_register_access(access, reg_number, NULL, cnt, "failed in transfer");
+            spi_tpm_helper_end_transaction(ctx);
+            return TSS2_TCTI_RC_IO_ERROR;
+        }
+        // End transaction
+        rc = spi_tpm_helper_end_transaction(ctx);
+        if (rc != TSS2_RC_SUCCESS) {
+            spi_tpm_helper_log_register_access(access, reg_number, NULL, cnt, "failed ending the transaction");
+            return TSS2_TCTI_RC_IO_ERROR;
+        }
+    } else {
+        // Append header
+        cnt2 = spi_tpm_helper_no_waitstate_preprocess(access, reg_number, (uint8_t *)buffer, buffer2, cnt);
+        // Read register
+        rc = spi_tpm_helper_spi_transfer(ctx, buffer2, buffer2, cnt2);
+        if (rc != TSS2_RC_SUCCESS) {
+            spi_tpm_helper_log_register_access(access, reg_number, NULL, cnt, "failed in transfer");
+            spi_tpm_helper_end_transaction(ctx);
+            return TSS2_TCTI_RC_IO_ERROR;
+        }
+        // Trim the response
+        spi_tpm_helper_no_waitstate_postprocess(access, (uint8_t *)buffer, buffer2, cnt2);
+    }
+
+    // Print debug information and return success
+    spi_tpm_helper_log_register_access(access, reg_number, buffer, cnt, NULL);
+    return TSS2_RC_SUCCESS;
+}
+
+static TSS2_RC spi_tpm_helper_write_reg(TSS2_TCTI_SPI_HELPER_CONTEXT* ctx, uint32_t reg_number, const void *buffer, size_t cnt)
+{
+    TSS2_RC rc;
+    enum TCTI_SPI_HELPER_REGISTER_ACCESS_TYPE access = TCTI_SPI_HELPER_REGISTER_WRITE;
+    bool has_waitstate = true;
+    uint8_t buffer2[68];
+    size_t cnt2 = 0;
+
+    // Check maximum register transfer size is 64 byte
+    if (cnt > 64) {
+        return TSS2_TCTI_RC_BAD_VALUE;
+    }
+
+    // Detect wait state configuration
+    if (ctx->platform.spi_acquire == NULL || ctx->platform.spi_release == NULL) {
+        has_waitstate = false;
+    }
+
+    // Start write transaction
+    if (has_waitstate) {
+        rc = spi_tpm_helper_start_transaction(ctx, access, cnt, reg_number);
+        if (rc != TSS2_RC_SUCCESS) {
+            spi_tpm_helper_end_transaction(ctx);
+            spi_tpm_helper_log_register_access(access, reg_number, buffer, cnt, "failed in transaction start");
+            return TSS2_TCTI_RC_IO_ERROR;
+        }
+        // Write register
+        rc = spi_tpm_helper_spi_transfer(ctx, buffer, NULL, cnt);
+        if (rc != TSS2_RC_SUCCESS) {
+            spi_tpm_helper_end_transaction(ctx);
+            spi_tpm_helper_log_register_access(access, reg_number, buffer, cnt, "failed in transfer");
+            return TSS2_TCTI_RC_IO_ERROR;
+        }
+        // End transaction
+        rc = spi_tpm_helper_end_transaction(ctx);
+        if (rc != TSS2_RC_SUCCESS) {
+            spi_tpm_helper_log_register_access(access, reg_number, NULL, cnt, "failed ending the transaction");
+            return TSS2_TCTI_RC_IO_ERROR;
+        }
+    } else {
+        // Append header
+        cnt2 = spi_tpm_helper_no_waitstate_preprocess(access, reg_number, (uint8_t *)buffer, buffer2, cnt);
+        // Write register
+        rc = spi_tpm_helper_spi_transfer(ctx, buffer2, NULL, cnt2);
+        if (rc != TSS2_RC_SUCCESS) {
+            spi_tpm_helper_end_transaction(ctx);
+            spi_tpm_helper_log_register_access(access, reg_number, buffer, cnt, "failed in transfer");
+            return TSS2_TCTI_RC_IO_ERROR;
+        }
+    }
+
+    // Print debug information and return success
+    spi_tpm_helper_log_register_access(access, reg_number, buffer, cnt, NULL);
+    return TSS2_RC_SUCCESS;
+}
+
+static uint32_t spi_tpm_helper_read_sts_reg(TSS2_TCTI_SPI_HELPER_CONTEXT* ctx)
+{
+    uint32_t status = 0;
+    spi_tpm_helper_read_reg(ctx, TCTI_SPI_HELPER_TPM_STS_REG, &status, sizeof(status));
+    return status;
+}
+
+static void spi_tpm_helper_write_sts_reg(TSS2_TCTI_SPI_HELPER_CONTEXT* ctx, uint32_t status)
+{
+    spi_tpm_helper_write_reg(ctx, TCTI_SPI_HELPER_TPM_STS_REG, &status, sizeof(status));
+}
+
+static uint32_t spi_tpm_helper_get_burst_count(TSS2_TCTI_SPI_HELPER_CONTEXT* ctx)
+{
+    uint32_t status = spi_tpm_helper_read_sts_reg(ctx);
+    return (status & TCTI_SPI_HELPER_TPM_STS_BURST_COUNT_MASK) >> TCTI_SPI_HELPER_TPM_STS_BURST_COUNT_SHIFT;
+}
+
+static uint8_t spi_tpm_helper_read_access_reg(TSS2_TCTI_SPI_HELPER_CONTEXT* ctx)
+{
+    uint8_t access = 0;
+    spi_tpm_helper_read_reg(ctx, TCTI_SPI_HELPER_TPM_ACCESS_REG, &access, sizeof(access));
+    return access;
+}
+
+static void spi_tpm_helper_write_access_reg(TSS2_TCTI_SPI_HELPER_CONTEXT* ctx, uint8_t access_bit)
+{
+    // Writes to access register can set only 1 bit at a time
+    if (access_bit & (access_bit - 1)) {
+        LOG_ERROR("Writes to access register can set only 1 bit at a time.");
+    } else {
+        spi_tpm_helper_write_reg(ctx, TCTI_SPI_HELPER_TPM_ACCESS_REG, &access_bit, sizeof(access_bit));
+    }
+}
+
+static TSS2_RC spi_tpm_helper_claim_locality(TSS2_TCTI_SPI_HELPER_CONTEXT* ctx)
+{
+    uint8_t access;
+    access = spi_tpm_helper_read_access_reg(ctx);
+
+    // Check if locality 0 is active
+    if (access & TCTI_SPI_HELPER_TPM_ACCESS_ACTIVE_LOCALITY) {
+        LOG_DEBUG("Locality 0 is already active, status: %#x", access);
+        return TSS2_RC_SUCCESS;
+    }
+
+    // Request locality 0
+    spi_tpm_helper_write_access_reg(ctx, TCTI_SPI_HELPER_TPM_ACCESS_REQUEST_USE);
+    access = spi_tpm_helper_read_access_reg(ctx);
+    if (access & (TCTI_SPI_HELPER_TPM_ACCESS_VALID | TCTI_SPI_HELPER_TPM_ACCESS_ACTIVE_LOCALITY)) {
+        LOG_DEBUG("Claimed locality 0");
+        return TSS2_RC_SUCCESS;
+    }
+
+    LOG_ERROR("Failed to claim locality 0, status: %#x", access);
+    return TSS2_TCTI_RC_IO_ERROR;
+}
+
+static TSS2_RC spi_tpm_helper_wait_for_status(TSS2_TCTI_SPI_HELPER_CONTEXT* ctx, uint32_t status_mask, uint32_t status_expected, int32_t timeout)
+{
+    uint32_t status;
+    bool blocking = (timeout == TSS2_TCTI_TIMEOUT_BLOCK);
+    if (!blocking) {
+        spi_tpm_helper_start_timeout(ctx, timeout);
+    }
+
+    // Wait for the expected status with or without timeout
+    do {
+        status = spi_tpm_helper_read_sts_reg(ctx);
+        // Return success on expected status
+        if ((status & status_mask) == status_expected) {
+            return TSS2_RC_SUCCESS;
+        }
+        // Delay next poll by 8ms to avoid spamming the TPM
+        spi_tpm_helper_delay_ms(ctx, 8);
+    } while (blocking || !spi_tpm_helper_timeout_expired(ctx));
+
+    // Timed out
+    return TSS2_TCTI_RC_TRY_AGAIN;
+}
+
+static inline size_t spi_tpm_helper_size_t_min(size_t a, size_t b) {
+    if (a < b) {
+        return a;
+    }
+    return b;
+}
+
+static void spi_tpm_helper_fifo_transfer(TSS2_TCTI_SPI_HELPER_CONTEXT* ctx, uint8_t* transfer_buffer, size_t transfer_size, enum TCTI_SPI_HELPER_FIFO_TRANSFER_DIRECTION direction)
+{
+    size_t transaction_size;
+    size_t burst_count;
+    size_t handled_so_far = 0;
+
+    do {
+        do {
+            // Can be zero when TPM is busy
+            burst_count = spi_tpm_helper_get_burst_count(ctx);
+        } while (!burst_count);
+
+        transaction_size = transfer_size - handled_so_far;
+        transaction_size = spi_tpm_helper_size_t_min(transaction_size, burst_count);
+        transaction_size = spi_tpm_helper_size_t_min(transaction_size, 64);
+
+        if (direction == TCTI_SPI_HELPER_FIFO_RECEIVE){
+            spi_tpm_helper_read_reg(ctx, TCTI_SPI_HELPER_TPM_DATA_FIFO_REG, (void*)(transfer_buffer + handled_so_far), transaction_size);
+        } else {
+            spi_tpm_helper_write_reg(ctx, TCTI_SPI_HELPER_TPM_DATA_FIFO_REG, (const void*)(transfer_buffer + handled_so_far), transaction_size);
+        }
+
+        handled_so_far += transaction_size;
+
+    } while (handled_so_far != transfer_size);
+}
+
+/*
+ * This function wraps the "up-cast" of the opaque TCTI context type to the
+ * type for the device TCTI context. The only safe-guard we have to ensure
+ * this operation is possible is the magic number for the device TCTI context.
+ * If passed a NULL context, or the magic number check fails, this function
+ * will return NULL.
+ */
+TSS2_TCTI_SPI_HELPER_CONTEXT* tcti_spi_helper_context_cast (TSS2_TCTI_CONTEXT *tcti_ctx)
+{
+    if (tcti_ctx != NULL && TSS2_TCTI_MAGIC (tcti_ctx) == TCTI_SPI_HELPER_MAGIC) {
+        return (TSS2_TCTI_SPI_HELPER_CONTEXT*)tcti_ctx;
+    }
+    return NULL;
+}
+
+/*
+ * This function down-casts the device TCTI context to the common context
+ * defined in the tcti-common module.
+ */
+TSS2_TCTI_COMMON_CONTEXT* tcti_spi_helper_down_cast (TSS2_TCTI_SPI_HELPER_CONTEXT *tcti_spi_helper)
+{
+    if (tcti_spi_helper == NULL) {
+        return NULL;
+    }
+    return &tcti_spi_helper->common;
+}
+
+TSS2_RC tcti_spi_helper_receive (TSS2_TCTI_CONTEXT* tcti_context, size_t *response_size, unsigned char *response_buffer, int32_t timeout)
+{
+    TSS2_RC rc;
+    TSS2_TCTI_SPI_HELPER_CONTEXT* tcti_spi_helper = tcti_spi_helper_context_cast (tcti_context);
+    TSS2_TCTI_COMMON_CONTEXT* tcti_common = tcti_spi_helper_down_cast (tcti_spi_helper);
+
+    if (tcti_spi_helper == NULL) {
+        return TSS2_TCTI_RC_BAD_CONTEXT;
+    }
+
+    rc = tcti_common_receive_checks (tcti_common, response_size, TCTI_SPI_HELPER_MAGIC);
+    if (rc != TSS2_RC_SUCCESS) {
+        return rc;
+    }
+
+    // Use ctx as a shorthand for tcti_spi_helper
+    TSS2_TCTI_SPI_HELPER_CONTEXT* ctx = tcti_spi_helper;
+
+    // Expected status bits for valid status and data availabe
+    uint32_t expected_status_bits = TCTI_SPI_HELPER_TPM_STS_VALID | TCTI_SPI_HELPER_TPM_STS_DATA_AVAIL;
+
+    // Check if we already have received the header
+    if (tcti_common->header.size == 0) {
+        // Wait for response to be ready
+        rc = spi_tpm_helper_wait_for_status(ctx, expected_status_bits, expected_status_bits, timeout);
+        if (rc != TSS2_RC_SUCCESS) {
+            LOG_ERROR("Failed waiting for status");
+            // Return rc from wait_for_status(). May be TRY_AGAIN after timeout.
+            return rc;
+        }
+
+        // Read only response header into context header buffer
+        rc = spi_tpm_helper_read_reg(ctx, TCTI_SPI_HELPER_TPM_DATA_FIFO_REG, ctx->header, TCTI_SPI_HELPER_RESP_HEADER_SIZE);
+        if (rc != TSS2_RC_SUCCESS) {
+            LOG_ERROR("Failed reading response header");
+            return TSS2_TCTI_RC_IO_ERROR;
+        }
+
+        // Find out the total payload size, skipping the two byte tag and update tcti_common
+        tcti_common->header.size = spi_tpm_helper_read_be32(ctx->header + 2);
+        LOG_TRACE("Read response size from response header: %" PRIu32 " bytes", tcti_common->header.size);
+    }
+
+    // Check if response size is requested
+    if (response_buffer == NULL) {
+        *response_size = tcti_common->header.size;
+        LOG_TRACE("Caller requested response size. Returning size of %zu bytes", *response_size);
+        return TSS2_RC_SUCCESS;
+    }
+
+    // Check if response fits in buffer and update response size
+    if (tcti_common->header.size > *response_size) {
+        LOG_ERROR("TPM response too long (%" PRIu32 " bytes)", tcti_common->header.size);
+        return TSS2_TCTI_RC_INSUFFICIENT_BUFFER;
+    }
+    *response_size = tcti_common->header.size;
+
+    // Receive the TPM response
+    LOG_TRACE("Reading response of size %" PRIu32, tcti_common->header.size);
+
+    // Copy already received header into response buffer
+    memcpy(response_buffer, ctx->header, TCTI_SPI_HELPER_RESP_HEADER_SIZE);
+
+    // Read all but the last byte in the FIFO
+    size_t bytes_to_go = tcti_common->header.size - 1 - TCTI_SPI_HELPER_RESP_HEADER_SIZE;
+    spi_tpm_helper_fifo_transfer(ctx, response_buffer + TCTI_SPI_HELPER_RESP_HEADER_SIZE, bytes_to_go, TCTI_SPI_HELPER_FIFO_RECEIVE);
+
+    // Verify that there is still data to read
+    uint32_t status = spi_tpm_helper_read_sts_reg(ctx);
+    if ((status & expected_status_bits) != expected_status_bits) {
+        LOG_ERROR("Unexpected intermediate status %#x",status);
+        return TSS2_TCTI_RC_IO_ERROR;
+    }
+
+    // Read the last byte
+    rc = spi_tpm_helper_read_reg(ctx, TCTI_SPI_HELPER_TPM_DATA_FIFO_REG, response_buffer + tcti_common->header.size - 1, 1);
+    if (rc != TSS2_RC_SUCCESS) {
+        return TSS2_TCTI_RC_IO_ERROR;
+    }
+
+    // Verify that there is no more data available
+    status = spi_tpm_helper_read_sts_reg(ctx);
+    if ((status & expected_status_bits) != TCTI_SPI_HELPER_TPM_STS_VALID) {
+        LOG_ERROR("Unexpected final status %#x", status);
+        return TSS2_TCTI_RC_IO_ERROR;
+    }
+
+    LOGBLOB_DEBUG(response_buffer, tcti_common->header.size, "Response buffer received:");
+
+    // Set the TPM back to idle state
+    spi_tpm_helper_write_sts_reg(ctx, TCTI_SPI_HELPER_TPM_STS_COMMAND_READY);
+
+    tcti_common->header.size = 0;
+    tcti_common->state = TCTI_STATE_TRANSMIT;
+
+    return TSS2_RC_SUCCESS;
+}
+
+void tcti_spi_helper_finalize (TSS2_TCTI_CONTEXT* tcti_context)
+{
+    TSS2_TCTI_SPI_HELPER_CONTEXT *tcti_spi_helper = tcti_spi_helper_context_cast (tcti_context);
+    TSS2_TCTI_COMMON_CONTEXT *tcti_common = tcti_spi_helper_down_cast (tcti_spi_helper);
+
+    if (tcti_spi_helper == NULL) {
+        return;
+    }
+    tcti_common->state = TCTI_STATE_FINAL;
+
+    // Free platform struct user data and resources inside
+    spi_tpm_helper_platform_finalize(tcti_spi_helper);
+}
+
+TSS2_RC tcti_spi_helper_transmit (TSS2_TCTI_CONTEXT *tcti_ctx, size_t size, const uint8_t *cmd_buf)
+{
+    TSS2_RC rc;
+    TSS2_TCTI_SPI_HELPER_CONTEXT *tcti_spi_helper = tcti_spi_helper_context_cast (tcti_ctx);
+    TSS2_TCTI_COMMON_CONTEXT *tcti_common = tcti_spi_helper_down_cast (tcti_spi_helper);
+    tpm_header_t header;
+
+    if (tcti_spi_helper == NULL) {
+        return TSS2_TCTI_RC_BAD_CONTEXT;
+    }
+    TSS2_TCTI_SPI_HELPER_CONTEXT* ctx = tcti_spi_helper;
+
+    rc = tcti_common_transmit_checks (tcti_common, cmd_buf, TCTI_SPI_HELPER_MAGIC);
+    if (rc != TSS2_RC_SUCCESS) {
+        return rc;
+    }
+    rc = header_unmarshal (cmd_buf, &header);
+    if (rc != TSS2_RC_SUCCESS) {
+        return rc;
+    }
+    if (header.size != size) {
+        LOG_ERROR("Buffer size parameter: %zu, and TPM2 command header size "
+                  "field: %" PRIu32 " disagree.", size, header.size);
+        return TSS2_TCTI_RC_BAD_VALUE;
+    }
+
+    LOGBLOB_DEBUG (cmd_buf, size, "Sending command with TPM_CC %#x and size %" PRIu32,
+               header.code, header.size);
+
+    // Tell TPM to expect command
+    spi_tpm_helper_write_sts_reg(ctx, TCTI_SPI_HELPER_TPM_STS_COMMAND_READY);
+
+    // Send command
+    spi_tpm_helper_fifo_transfer(ctx, (void*)cmd_buf, size, TCTI_SPI_HELPER_FIFO_TRANSMIT);
+
+    // Tell TPM to start processing the command
+    spi_tpm_helper_write_sts_reg(ctx, TCTI_SPI_HELPER_TPM_STS_GO);
+
+    tcti_common->state = TCTI_STATE_RECEIVE;
+    return TSS2_RC_SUCCESS;
+}
+
+TSS2_RC tcti_spi_helper_cancel (TSS2_TCTI_CONTEXT* tcti_context)
+{
+    (void)(tcti_context);
+    return TSS2_TCTI_RC_NOT_IMPLEMENTED;
+}
+
+TSS2_RC tcti_spi_helper_get_poll_handles (TSS2_TCTI_CONTEXT* tcti_context, TSS2_TCTI_POLL_HANDLE *handles, size_t *num_handles)
+{
+    (void)(tcti_context);
+    (void)(handles);
+    (void)(num_handles);
+    return TSS2_TCTI_RC_NOT_IMPLEMENTED;
+}
+
+TSS2_RC tcti_spi_helper_set_locality (TSS2_TCTI_CONTEXT* tcti_context, uint8_t locality)
+{
+    (void)(tcti_context);
+    (void)(locality);
+    return TSS2_TCTI_RC_NOT_IMPLEMENTED;
+}
+
+TSS2_RC Tss2_Tcti_Spi_Helper_Init (TSS2_TCTI_CONTEXT* tcti_context, size_t* size, TSS2_TCTI_SPI_HELPER_PLATFORM platform_conf)
+{
+    TSS2_RC rc;
+    TSS2_TCTI_SPI_HELPER_CONTEXT* tcti_spi_helper;
+    TSS2_TCTI_COMMON_CONTEXT* tcti_common;
+
+    // Check if context size is requested
+    if (tcti_context == NULL) {
+        *size = sizeof (TSS2_TCTI_SPI_HELPER_CONTEXT);
+        return TSS2_RC_SUCCESS;
+    }
+
+    // Init TCTI context
+    TSS2_TCTI_MAGIC (tcti_context) = TCTI_SPI_HELPER_MAGIC;
+    TSS2_TCTI_VERSION (tcti_context) = TCTI_VERSION;
+    TSS2_TCTI_TRANSMIT (tcti_context) = tcti_spi_helper_transmit;
+    TSS2_TCTI_RECEIVE (tcti_context) = tcti_spi_helper_receive;
+    TSS2_TCTI_FINALIZE (tcti_context) = tcti_spi_helper_finalize;
+    TSS2_TCTI_CANCEL (tcti_context) = tcti_spi_helper_cancel;
+    TSS2_TCTI_GET_POLL_HANDLES (tcti_context) = tcti_spi_helper_get_poll_handles;
+    TSS2_TCTI_SET_LOCALITY (tcti_context) = tcti_spi_helper_set_locality;
+    TSS2_TCTI_MAKE_STICKY (tcti_context) = tcti_make_sticky_not_implemented;
+
+    // Init SPI TCTI context
+    tcti_spi_helper = tcti_spi_helper_context_cast (tcti_context);
+    tcti_common = tcti_spi_helper_down_cast (tcti_spi_helper);
+    tcti_common->state = TCTI_STATE_TRANSMIT;
+    memset (&tcti_common->header, 0, sizeof (tcti_common->header));
+    tcti_common->locality = 0;
+
+    // Copy platform struct into context
+    tcti_spi_helper->platform = platform_conf;
+
+    // Probe TPM
+    TSS2_TCTI_SPI_HELPER_CONTEXT* ctx = tcti_spi_helper;
+    LOG_DEBUG("Probing TPM...");
+    uint32_t did_vid = 0;
+    for (int retries = 100; retries > 0; retries--) {
+        // In case of failed read div_vid is set to zero
+        spi_tpm_helper_read_reg(ctx, TCTI_SPI_HELPER_TPM_DID_VID_REG, &did_vid, sizeof(did_vid));
+        if (did_vid != 0) break;
+        // TPM might be resetting, let's retry in a bit
+        spi_tpm_helper_delay_ms(ctx, 10);
+    }
+    if (did_vid == 0) {
+        LOG_ERROR("Probing TPM failed");
+        return TSS2_TCTI_RC_IO_ERROR;
+    }
+    LOG_DEBUG("Probing TPM successful");
+
+    // Claim locality
+    LOG_DEBUG("Claiming TPM locality...");
+    rc = spi_tpm_helper_claim_locality(ctx);
+    if (rc != TSS2_RC_SUCCESS) {
+        return TSS2_TCTI_RC_IO_ERROR;
+    }
+
+    // Wait up to 200ms for TPM to become ready
+    LOG_DEBUG("Waiting for TPM to become ready...");
+    uint32_t expected_status_bits = TCTI_SPI_HELPER_TPM_STS_COMMAND_READY;
+    rc = spi_tpm_helper_wait_for_status(ctx, expected_status_bits, expected_status_bits, 200);
+    if (rc != TSS2_RC_SUCCESS) {
+        LOG_ERROR("Failed waiting for TPM to become ready");
+        return rc;
+    }
+    LOG_DEBUG("TPM is ready");
+
+    // Get rid
+    uint8_t rid = 0;
+    spi_tpm_helper_read_reg(ctx, TCTI_SPI_HELPER_TPM_RID_REG, &rid, sizeof(rid));
+
+#if MAXLOGLEVEL >= LOGL_INFO
+    // Print device details
+    uint16_t vendor_id, device_id, revision;
+    vendor_id = did_vid & 0xffff;
+    device_id = did_vid >> 16;
+    revision = rid;
+    LOG_INFO("Connected to TPM with vid:did:rid of %4.4x:%4.4x:%2.2x", vendor_id, device_id, revision);
+#endif
+
+    return TSS2_RC_SUCCESS;
+}
+
+static const TSS2_TCTI_INFO tss2_tcti_info = {
+    .version = TCTI_VERSION,
+    .name = "tcti-spi-helper",
+    .description = "Platform independent TCTI for communication with TPMs over SPI.",
+    .config_help = "TSS2_TCTI_SPI_HELPER_PLATFORM struct containing platform methods. See tss2_tcti_spi_helper.h for more information.",
+
+    /*
+     * The Tss2_Tcti_Spi_Helper_Init method has a different signature than required by .init due too
+     * our custom platform_conf parameter, so we can't expose it here and it has to be used directly.
+     */
+    .init = NULL,
+};
+
+const TSS2_TCTI_INFO* Tss2_Tcti_Info (void)
+{
+    return &tss2_tcti_info;
+}
diff --git a/src/tss2-tcti/tcti-spi-helper.h b/src/tss2-tcti/tcti-spi-helper.h
new file mode 100644
index 000000000..98cfb3429
--- /dev/null
+++ b/src/tss2-tcti/tcti-spi-helper.h
@@ -0,0 +1,57 @@
+/* SPDX-License-Identifier: BSD-2-Clause */
+/*
+ * Copyright 2020 Fraunhofer SIT. All rights reserved.
+ */
+#ifndef TCTI_SPI_HELPER_HELPER_H
+#define TCTI_SPI_HELPER_HELPER_H
+
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "tcti-common.h"
+
+#define TCTI_SPI_HELPER_MAGIC 0x4D5C6E8BD4811477ULL
+
+#define TCTI_SPI_HELPER_RESP_HEADER_SIZE 6
+
+typedef struct {
+    TSS2_TCTI_COMMON_CONTEXT common;
+    TSS2_TCTI_SPI_HELPER_PLATFORM platform;
+    char header[TCTI_SPI_HELPER_RESP_HEADER_SIZE];
+} TSS2_TCTI_SPI_HELPER_CONTEXT;
+
+#define TCTI_SPI_HELPER_TPM_LOCALITY_0    0x00D40000
+#define TCTI_SPI_HELPER_TPM_ACCESS_REG    (TCTI_SPI_HELPER_TPM_LOCALITY_0 + 0)
+#define TCTI_SPI_HELPER_TPM_STS_REG       (TCTI_SPI_HELPER_TPM_LOCALITY_0 + 0x18)
+#define TCTI_SPI_HELPER_TPM_DATA_FIFO_REG (TCTI_SPI_HELPER_TPM_LOCALITY_0 + 0x24)
+#define TCTI_SPI_HELPER_TPM_DID_VID_REG   (TCTI_SPI_HELPER_TPM_LOCALITY_0 + 0xF00)
+#define TCTI_SPI_HELPER_TPM_RID_REG       (TCTI_SPI_HELPER_TPM_LOCALITY_0 + 0xF04)
+
+enum TCTI_SPI_HELPER_TPM_ACCESS {
+    TCTI_SPI_HELPER_TPM_ACCESS_VALID = (1 << 7),
+    TCTI_SPI_HELPER_TPM_ACCESS_ACTIVE_LOCALITY = (1 << 5),
+    TCTI_SPI_HELPER_TPM_ACCESS_REQUEST_USE = (1 << 1)
+};
+
+enum TCTI_SPI_HELPER_TPM_STATUS {
+    TCTI_SPI_HELPER_TPM_STS_BURST_COUNT_SHIFT = 8,
+    TCTI_SPI_HELPER_TPM_STS_BURST_COUNT_MASK = (0xFFFF << TCTI_SPI_HELPER_TPM_STS_BURST_COUNT_SHIFT),
+    TCTI_SPI_HELPER_TPM_STS_VALID = (1 << 7),
+    TCTI_SPI_HELPER_TPM_STS_COMMAND_READY = (1 << 6),
+    TCTI_SPI_HELPER_TPM_STS_GO = (1 << 5),
+    TCTI_SPI_HELPER_TPM_STS_DATA_AVAIL = (1 << 4),
+    TCTI_SPI_HELPER_TPM_STS_DATA_EXPECT = (1 << 3)
+};
+
+enum TCTI_SPI_HELPER_FIFO_TRANSFER_DIRECTION {
+    TCTI_SPI_HELPER_FIFO_TRANSMIT = 0,
+    TCTI_SPI_HELPER_FIFO_RECEIVE = 1
+};
+
+enum TCTI_SPI_HELPER_REGISTER_ACCESS_TYPE {
+    TCTI_SPI_HELPER_REGISTER_WRITE = 0,
+    TCTI_SPI_HELPER_REGISTER_READ = 1
+};
+
+#endif /* TCTI_SPI_HELPER_HELPER_H */
diff --git a/test/unit/tcti-spi-helper.c b/test/unit/tcti-spi-helper.c
new file mode 100644
index 000000000..c254633af
--- /dev/null
+++ b/test/unit/tcti-spi-helper.c
@@ -0,0 +1,269 @@
+/* SPDX-License-Identifier: BSD-2-Clause */
+/***********************************************************************;
+ * Copyright (c) 2022, Infineon Technologies AG
+ * All rights reserved.
+ ***********************************************************************/
+
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <inttypes.h>
+#include <limits.h>
+#include <stdio.h>
+#include <stdbool.h>
+#include <stdlib.h>
+#include <string.h>
+
+#include <setjmp.h>
+#include <cmocka.h>
+
+#include "tss2_tcti.h"
+#include "tss2_tcti_spi_helper.h"
+
+#include "tss2-tcti/tcti-common.h"
+#include "tss2-tcti/tcti-spi-helper.h"
+#include "util/key-value-parse.h"
+
+#define DUMMY_PLATFORM_DATA "my platform data"
+
+typedef enum {
+    TPM_DID_VID_HEAD = 0,
+    TPM_DID_VID_BODY,
+    TPM_ACCESS_HEAD,
+    TPM_ACCESS_BODY,
+    TPM_STS_HEAD,
+    TPM_STS_BODY,
+    TPM_RID_HEAD,
+    TPM_RID_BODY
+} tpm_state_t;
+
+static const unsigned char TPM_DID_VID_0[] = {0x83, 0xd4, 0x0f, 0x00, 0xd1, 0x15, 0x1b, 0x00};
+static const unsigned char TPM_ACCESS_0[] = {0x80, 0xd4, 0x00, 0x00, 0xa1};
+static const unsigned char TPM_STS_0[] = {0x83, 0xd4, 0x00, 0x18, 0x40, 0x00, 0x00, 0x00};
+static const unsigned char TPM_RID_0[] = {0x80, 0xd4, 0x0f, 0x04, 0x00};
+
+void platform_sleep_ms (void* user_data, int32_t milliseconds)
+{
+    (void) milliseconds;
+    assert_string_equal ((const char *) user_data, DUMMY_PLATFORM_DATA);
+}
+
+void platform_start_timeout (void* user_data, int32_t milliseconds)
+{
+    (void) milliseconds;
+    assert_string_equal ((const char *) user_data, DUMMY_PLATFORM_DATA);
+}
+
+bool platform_timeout_expired (void* user_data)
+{
+    assert_string_equal ((const char *) user_data, DUMMY_PLATFORM_DATA);
+    return true;
+}
+
+TSS2_RC platform_spi_acquire (void* user_data)
+{
+    (void) user_data;
+    return TSS2_RC_SUCCESS;
+}
+
+TSS2_RC platform_spi_release (void* user_data)
+{
+    (void) user_data;
+    return TSS2_RC_SUCCESS;
+}
+
+TSS2_RC platform_spi_transfer_no_wait_state (void* user_data, const void *data_out, void *data_in, size_t cnt)
+{
+    static tpm_state_t tpm_state = TPM_DID_VID_HEAD;
+
+    assert_string_equal ((const char *) user_data, DUMMY_PLATFORM_DATA);
+
+    switch (tpm_state) {
+    case TPM_DID_VID_HEAD:
+        assert_int_equal (cnt, 8);
+        assert_true (!memcmp (data_out, TPM_DID_VID_0, 4));
+        memcpy (data_in, TPM_DID_VID_0, sizeof (TPM_DID_VID_0));
+        break;
+    case TPM_ACCESS_HEAD:
+        assert_int_equal (cnt, 5);
+        assert_true (!memcmp (data_out, TPM_ACCESS_0, 4));
+        memcpy (data_in, TPM_ACCESS_0, sizeof (TPM_ACCESS_0));
+        break;
+    case TPM_STS_HEAD:
+        assert_int_equal (cnt, 8);
+        assert_true (!memcmp (data_out, TPM_STS_0, 4));
+        memcpy (data_in, TPM_STS_0, sizeof (TPM_STS_0));
+        break;
+    case TPM_RID_HEAD:
+        assert_int_equal (cnt, 5);
+        assert_true (!memcmp (data_out, TPM_RID_0, 4));
+        memcpy (data_in, TPM_RID_0, sizeof (TPM_RID_0));
+        break;
+    default:
+        assert_true (false);
+    }
+
+    tpm_state += 2;
+
+    return TSS2_RC_SUCCESS;
+}
+
+TSS2_RC platform_spi_transfer_with_wait_state (void* user_data, const void *data_out, void *data_in, size_t cnt)
+{
+    static tpm_state_t tpm_state = TPM_DID_VID_HEAD;
+
+    assert_string_equal ((const char *) user_data, DUMMY_PLATFORM_DATA);
+
+    switch (tpm_state++) {
+    case TPM_DID_VID_HEAD:
+        assert_int_equal (cnt, 4);
+        assert_true (!memcmp (data_out, TPM_DID_VID_0, 4));
+        memcpy (data_in, TPM_DID_VID_0, 4);
+        ((unsigned char *)data_in)[3] |= 0x01;
+        break;
+    case TPM_DID_VID_BODY:
+        assert_int_equal (cnt, sizeof (TPM_DID_VID_0) - 4);
+        memcpy (data_in, TPM_DID_VID_0 + 4, sizeof (TPM_DID_VID_0) - 4);
+        break;
+    case TPM_ACCESS_HEAD:
+        assert_int_equal (cnt, 4);
+        assert_true (!memcmp (data_out, TPM_ACCESS_0, 4));
+        memcpy (data_in, TPM_ACCESS_0, 4);
+        ((unsigned char *)data_in)[3] |= 0x01;
+        break;
+    case TPM_ACCESS_BODY:
+        assert_int_equal (cnt, sizeof (TPM_ACCESS_0) - 4);
+        memcpy (data_in, TPM_ACCESS_0 + 4, sizeof (TPM_ACCESS_0) - 4);
+        break;
+    case TPM_STS_HEAD:
+        assert_int_equal (cnt, 4);
+        assert_true (!memcmp (data_out, TPM_STS_0, 4));
+        memcpy (data_in, TPM_STS_0, 4);
+        ((unsigned char *)data_in)[3] |= 0x01;
+        break;
+    case TPM_STS_BODY:
+        assert_int_equal (cnt, sizeof (TPM_STS_0) - 4);
+        memcpy (data_in, TPM_STS_0 + 4, sizeof (TPM_STS_0) - 4);
+        break;
+    case TPM_RID_HEAD:
+        assert_int_equal (cnt, 4);
+        assert_true (!memcmp (data_out, TPM_RID_0, 4));
+        memcpy (data_in, TPM_RID_0, 4);
+        ((unsigned char *)data_in)[3] |= 0x01;
+        break;
+    case TPM_RID_BODY:
+        assert_int_equal (cnt, sizeof (TPM_RID_0) - 4);
+        memcpy (data_in, TPM_RID_0 + 4, 1);
+        break;
+    default:
+        assert_true (false);
+    }
+
+    return TSS2_RC_SUCCESS;
+}
+
+void platform_finalize(void* user_data)
+{
+    assert_string_equal ((const char *) user_data, DUMMY_PLATFORM_DATA);
+    free(user_data);
+}
+
+TSS2_TCTI_SPI_HELPER_PLATFORM create_tcti_spi_helper_platform (bool wait_state)
+{
+    TSS2_TCTI_SPI_HELPER_PLATFORM platform = {};
+
+    // Create dummy platform user data
+    char *platform_data = malloc (sizeof (DUMMY_PLATFORM_DATA));
+    memcpy (platform_data, DUMMY_PLATFORM_DATA, sizeof (DUMMY_PLATFORM_DATA));
+
+    // Create TCTI SPI platform struct with custom platform methods
+    platform.user_data = platform_data;
+    platform.sleep_ms = platform_sleep_ms;
+    platform.start_timeout = platform_start_timeout;
+    platform.timeout_expired = platform_timeout_expired;
+    if (wait_state) {
+        platform.spi_acquire = platform_spi_acquire;
+        platform.spi_release = platform_spi_release;
+        platform.spi_transfer = platform_spi_transfer_with_wait_state;
+    } else {
+        platform.spi_acquire = NULL;
+        platform.spi_release = NULL;
+        platform.spi_transfer = platform_spi_transfer_no_wait_state;
+    }
+    platform.finalize = platform_finalize;
+
+    return platform;
+}
+
+/*
+ * The test will invoke Tss2_Tcti_Spi_Helper_Init() and subsequently
+ * it will start reading TPM_DID_VID, claim locality, read TPM_STS,
+ * and finally read TPM_RID before exiting the Init function.
+ * For testing purpose, the TPM responses are hardcoded.
+ * SPI wait state is not supported in this test.
+ */
+static void
+tcti_spi_no_wait_state_success_test (void **state)
+{
+    TSS2_RC rc;
+    size_t size;
+    TSS2_TCTI_SPI_HELPER_PLATFORM tcti_platform = {};
+    TSS2_TCTI_CONTEXT* tcti_ctx;
+
+    // Get requested TCTI context size
+    rc = Tss2_Tcti_Spi_Helper_Init (NULL, &size, tcti_platform);
+    assert_int_equal (rc, TSS2_RC_SUCCESS);
+
+    // Allocate TCTI context size
+    tcti_ctx = (TSS2_TCTI_CONTEXT*) calloc (1, size);
+    assert_non_null (tcti_ctx);
+
+    // Initialize TCTI context
+    tcti_platform = create_tcti_spi_helper_platform (false);
+    rc = Tss2_Tcti_Spi_Helper_Init (tcti_ctx, &size, tcti_platform);
+    assert_int_equal (rc, TSS2_RC_SUCCESS);
+
+    free (tcti_platform.user_data);
+    free (tcti_ctx);
+}
+
+/*
+ * Similar to tcti_spi_no_wait_state_success_test
+ * except wait state is supported here.
+ */
+static void
+tcti_spi_with_wait_state_success_test (void **state)
+{
+    TSS2_RC rc;
+    size_t size;
+    TSS2_TCTI_SPI_HELPER_PLATFORM tcti_platform = {};
+    TSS2_TCTI_CONTEXT* tcti_ctx;
+
+    // Get requested TCTI context size
+    rc = Tss2_Tcti_Spi_Helper_Init (NULL, &size, tcti_platform);
+    assert_int_equal (rc, TSS2_RC_SUCCESS);
+
+    // Allocate TCTI context size
+    tcti_ctx = (TSS2_TCTI_CONTEXT*) calloc (1, size);
+    assert_non_null (tcti_ctx);
+
+    // Initialize TCTI context
+    tcti_platform = create_tcti_spi_helper_platform (true);
+    rc = Tss2_Tcti_Spi_Helper_Init (tcti_ctx, &size, tcti_platform);
+    assert_int_equal (rc, TSS2_RC_SUCCESS);
+
+    free (tcti_platform.user_data);
+    free (tcti_ctx);
+}
+
+int
+main (int   argc,
+      char *argv[])
+{
+    const struct CMUnitTest tests[] = {
+        cmocka_unit_test (tcti_spi_no_wait_state_success_test),
+        cmocka_unit_test (tcti_spi_with_wait_state_success_test),
+    };
+    return cmocka_run_group_tests (tests, NULL, NULL);
+}
